% Variables Definitions
i_ = 1;
SET.variable.r = i_; i_ = i_ + 1;
SET.variable.yhat = i_; i_ = i_ + 1;
SET.variable.x    = i_; i_ = i_ + 1;
SET.variable.ppi  = i_; i_ = i_ + 1;
SET.variable.ppi_target = i_; i_ = i_ + 1; 
SET.variable.g  = i_; i_ = i_ + 1;
SET.variable.om = i_; i_ = i_ + 1;
SET.variable.m  = i_; i_ = i_ + 1; 
SET.variable.a  = i_; i_ = i_ + 1;
SET.variable.e  = i_; i_ = i_ + 1;
SET.variable.v  = i_; i_ = i_ + 1; 
SET.variable.z  = i_; i_ = i_ + 1;
SET.variable.const = i_;  

SET.varnames{1} = 'r';
SET.varnames{2} = 'yhat';
SET.varnames{3} = 'x';
SET.varnames{4} = 'ppi';
SET.varnames{5} = 'ppi_target';
SET.varnames{6} = 'g';
SET.varnames{7} = 'om';
SET.varnames{8} = 'm';
SET.varnames{9} = 'a';
SET.varnames{10} = 'e';
SET.varnames{11} = 'v';
SET.varnames{12} = 'z';

%Options
%Calibration
% SET.options.country = 'USA'; %Choose USA or Argentina
% Type of disinflation
SET.options.money_rule    = 0; % Set to 1 for money growth rule or 0 otherwise.
SET.options.taylor_rule   = 1 - SET.options.money_rule; % Set to 1 for interest rate rule or 0 otherwise.
SET.options.money_rule_f  = 0;
SET.options.taylor_rule_f = 1 - SET.options.money_rule_f; 

SET.options.unanticipated = 1; % Set to 1 for unanticipated and 0 for anticipated. 
SET.options.anticipated   = 1 - SET.options.unanticipated ; 
SET.param.rho_target      = 0.;% 0.2044;   % 
SET.param.rho_target_f    = 0.; % 0.2044; % Set to 0 for Cold Turkey

% Policy makers preferences:
SET.param.policyDiscFactor = 0.995;
SET.param.weight_x = 0.05;  % Weight on the Loss function on the output gap
SET.param.T_loss   = 500; % 
SET.param.scale_loss   = 10000; % 

SET.param.Delta_ppi = 10;  % Size of Disinflation
SET.options.T       = 600; % Length of the simulation
SET.options.T_star  = 300;  % Date of the regime change. 
SET.options.T_a     = 298;  % Date of announcement. Date agents know of the forthcoming structural change.
SET.options.Tdisin  = 75;  % Tolerance date for computing success ratios
SET.options.band    = 2;    % In annual percent around the inflation target. Used to compute succesful disinflations.  
SET.options.draws   = 1;
SET.options.dates_disin = 100; % Maximum number of classified disinflations
SET.options.idendify_band = 9; % Sets the window in which a disinflation is classified as due to policy under Ball's identification method.
SET.options.Ball_sample = 100; % Sets the size of the window to search for disinflations centered at T_star.
SET.options.min_dis_size = 2; % Sets the minimum size of change inflation that is classified as a disinflation episode.
SET.options.stochastic = 1; % Set to 1 for stochastic and 0 for nonstochastic.
SET.options.randnstate = 17;
SET.options.states = 'msv'; % 'state_no_target'; 
SET.options.doplots = 0; 
SET.options.from = SET.options.T_star-20;
SET.options.upto = SET.options.T_star+20;
SET.options.display = 0;


SET.param.gain       = 0.02; % gain parameter
SET.param.lambda     = 0; % Weight on Rational Expectations 


%Scaling Shocks
SET.param.adjust     = 0; %Controls how many standard deviations from posterior mode shocks are drawn


% Parameters

if strcmp(SET.options.country, 'Argentina')==1

SET.param.beta     = 0.995;
SET.param.zbar     = 0.004783;
SET.param.ppibar   = 40/400; % 45.77/400;0.0887;
SET.param.rho_a    = 0.9179;
SET.param.rho_e    = 0.9606;
SET.param.rho_z    = 0.3755;
SET.param.rho_v    = 0.9178;
SET.param.omeg     = 0.0617;
SET.param.psi      = 0.1;
SET.param.mu_a     = -0.1669;
SET.param.mu_e     = -0.0597;
SET.param.mu_z     = 0.1603;
SET.param.mu_v     = 0.1776;
SET.param.mu_a_f   = 0;
SET.param.mu_e_f   = 0;
SET.param.mu_z_f   = 0;
SET.param.mu_v_f   = 0;

% %Interest Rate Rule
SET.param.rho_r    = 0.9674; 
SET.param.rho_pi   = 0.3749;
SET.param.rho_g    = 0.3228;
SET.param.rho_x    = 0.0075;
SET.param.rho_r_f  = 0.9674; 
SET.param.rho_pi_f = 0.3749;
SET.param.rho_g_f  = 0.3228;
SET.param.rho_x_f  = 0.0075;

%Money Rule
SET.param.rho_om     = 0.3; 
SET.param.rho_om_pi  = -1.5;
SET.param.rho_om_g   = -0.6;
SET.param.rho_om_x   = -.5;


SET.param.rho_om_f    =  0.3;
SET.param.rho_om_pi_f = -1.5;
SET.param.rho_om_g_f  = -0.6;
SET.param.rho_om_x_f  = -0.5;

%Shocks
SET.param.sig_a      = 0.0089;
SET.param.sig_e      = 0.0061;
SET.param.sig_z      = 0.0051;
SET.param.sig_r      = 0.0051;
SET.param.sig_om     = 0.0000;
SET.param.sig_target = 0.0036;
SET.param.sig_v      = 0.0354;

% US Shocks
% SET.param.sig_a      = 0.0139;
% SET.param.sig_e      = 0.0008;
% SET.param.sig_z      = 0.0090;
% SET.param.sig_r      = 0.0040;
% SET.param.sig_om     = 0.0000;
% SET.param.sig_target = 0.0014;
% SET.param.sig_v      = 0.0799;


%Std of Shocks... Used for scaling variance of shocks when adjust>0.
SET.param.sig_sig_a      = 0.0034;
SET.param.sig_sig_e      = 0.0008;
SET.param.sig_sig_z      = 0.0018;
SET.param.sig_sig_r      = 0.0009;
SET.param.sig_sig_om     = 0.0000;
SET.param.sig_sig_target = 0.0010;
SET.param.sig_sig_v      = 0.0129;

elseif strcmp(SET.options.country,'USA') ==1
    
SET.param.beta     = 0.995;
SET.param.zbar     = 0.004783;
SET.param.ppibar   = 12/400;
SET.param.rho_a    = 0.8592;
SET.param.rho_e    = 0.8620;
SET.param.rho_z    = 0.0715;
SET.param.rho_v    = 0.9632;
SET.param.omeg     = 0.0617;
SET.param.psi      = 0.1;
SET.param.mu_a     = -0.2999;
SET.param.mu_e     = 0.8573;
SET.param.mu_z     = -0.0269;
SET.param.mu_v     = 0.0372;
SET.param.mu_a_f   = 0;
SET.param.mu_e_f   = 0;
SET.param.mu_z_f   = 0;
SET.param.mu_v_f   = 0;

%Interest Rate Rule
SET.param.rho_r    = 0.9736; 
SET.param.rho_pi   = 0.7901;
SET.param.rho_g    = 0.8662;
SET.param.rho_x    = 0.1846;
SET.param.rho_r_f  = 0.9736; 
SET.param.rho_pi_f = 0.7901;
SET.param.rho_g_f  = 0.8662;
SET.param.rho_x_f  = 0.1846;

% SET.param.rho_r    = 0.0 ;
% SET.param.rho_pi   = 1.5;
% SET.param.rho_g    = 0;
% SET.param.rho_x    = 0;
% SET.param.rho_r_f  = 0; 
% SET.param.rho_pi_f = 1.5;
% SET.param.rho_g_f  = 0;
% SET.param.rho_x_f  = 0;

%Money Rule
SET.param.rho_om     = 0.3; 
SET.param.rho_om_pi  = -1.5;
SET.param.rho_om_g   = -0.6;
SET.param.rho_om_x   = -.5;


SET.param.rho_om_f    =  0.3;
SET.param.rho_om_pi_f = -1.5;
SET.param.rho_om_g_f  = -0.6;
SET.param.rho_om_x_f  = -0.5;

%Shocks
SET.param.sig_a      = 0.0139;
SET.param.sig_e      = 0.0008;
SET.param.sig_z      = 0.0090;
SET.param.sig_r      = 0.0040;
SET.param.sig_om     = 0.0000;
SET.param.sig_target = 0.0014;
SET.param.sig_v      = 0.0799;

%Std of Shocks... Used for scaling variance of shocks when adjust>0.
SET.param.sig_sig_a      = 0.0025;
SET.param.sig_sig_e      = 0.0002;
SET.param.sig_sig_z      = 0.0011;
SET.param.sig_sig_r      = 0.0006;
SET.param.sig_sig_om     = 0.0000;
SET.param.sig_sig_target = 0.0002;
SET.param.sig_sig_v      = 0.0065;
    
else
    error('country not supported');
end