**** Identifying Disinflation Episodes and Calculating SaRs - Gibbs and Kulish (2017)
* This program identifies sacrifice ratios using Ball (1994)'s procedure and then calculates
* the sacrifice ratio using two means: 1) cumulative difference in the growth rate from average growth rate calculated
* from all available data. 2) cumulative difference in growth rate from trend growth. 
* The summation of growth rates begins in the first quarter of the disinfaltion episode
* and ends four quarters following the trough.
* Previous Updated: 31/5/2015
* Last Updated: 8/8/2017

clear
set matsize 5000
cd "CHANGE DIRECTORY BEFORE USE/Data"

use oecd_inflation

append using matching_argentina_data

replace country_id=49 if country_id==.

* Create 9-quarter moving average to identify  peaks and troughts

forv i=8(1)216 {
local j1 = `i' - 8
local j2 = `i' - 7
local j3 = `i' - 6
local j4 = `i' - 5
local j5 = `i' - 4
local j6 = `i' - 3
local j7 = `i' - 2
local j8 = `i' - 1
local j9 = `i' - 0
egen inf_ma9_`j5' = rowmean(inflation`j1' inflation`j2' inflation`j3' inflation`j4' inflation`j5' inflation`j6' inflation`j7' inflation`j8' inflation`j9')
}


* Find Troughs Peaks using Ball's definitions
gen counter = 1
gen type_id= -20
/*
forv i=16(1)216 {
local j1 = `i' - 8
local j2 = `i' - 7
local j3 = `i' - 6
local j4 = `i' - 5
local j5 = `i' - 4
local j6 = `i' - 3
local j7 = `i' - 2
local j8 = `i' - 1
local j9 = `i' - 0
gen peak_`j5' = 0
gen disinflation_indicator`j5' =0
novarabbrev {
replace peak_`j5' = 1 if inf_ma9_`j5'>type_id & inf_ma9_`j5'> inf_ma9_`j1' & inf_ma9_`j5'> inf_ma9_`j2' & inf_ma9_`j5'> inf_ma9_`j3' & inf_ma9_`j5'> inf_ma9_`j4' & inf_ma9_`j5'> inf_ma9_`j6' & inf_ma9_`j5'> inf_ma9_`j7' & inf_ma9_`j5'> inf_ma9_`j8' & inf_ma9_`j5'> inf_ma9_`j9' 
replace type_id = 2 if type_id==1 & inf_ma9_`j5'> inf_ma9_`j1' & inf_ma9_`j5'> inf_ma9_`j2' & inf_ma9_`j5'> inf_ma9_`j3' & inf_ma9_`j5'> inf_ma9_`j4' & inf_ma9_`j5'> inf_ma9_`j6' & inf_ma9_`j5'> inf_ma9_`j7' & inf_ma9_`j5'> inf_ma9_`j8' & inf_ma9_`j5'> inf_ma9_`j9' 
replace disinflation_indicator`j5' = counter if type_id==2
replace peak_`j5' = 2 if inf_ma9_`j5'<type_id & inf_ma9_`j5'< inf_ma9_`j1' & inf_ma9_`j5'< inf_ma9_`j2' & inf_ma9_`j5'< inf_ma9_`j3' & inf_ma9_`j5'< inf_ma9_`j4' & inf_ma9_`j5'< inf_ma9_`j6' & inf_ma9_`j5'< inf_ma9_`j7' & inf_ma9_`j5'< inf_ma9_`j8' & inf_ma9_`j5'< inf_ma9_`j9' 
replace type_id = 1 if type_id==2 & inf_ma9_`j5'< inf_ma9_`j1' & inf_ma9_`j5'< inf_ma9_`j2' & inf_ma9_`j5'< inf_ma9_`j3' & inf_ma9_`j5'< inf_ma9_`j4' & inf_ma9_`j5'< inf_ma9_`j6' & inf_ma9_`j5'< inf_ma9_`j7' & inf_ma9_`j5'< inf_ma9_`j8' & inf_ma9_`j5'< inf_ma9_`j9' 
replace counter = counter + 1 if type_id==2 & inf_ma9_`j5'< inf_ma9_`j1' & inf_ma9_`j5'< inf_ma9_`j2' & inf_ma9_`j5'< inf_ma9_`j3' & inf_ma9_`j5'< inf_ma9_`j4' & inf_ma9_`j5'< inf_ma9_`j6' & inf_ma9_`j5'< inf_ma9_`j7' & inf_ma9_`j5'< inf_ma9_`j8' & inf_ma9_`j5'< inf_ma9_`j9' 
}
}*/

* Find Troughs Peaks
replace type_id= 1
forv i=12(1)212 {
local j1 = `i' - 8
local j2 = `i' - 7
local j3 = `i' - 6
local j4 = `i' - 5
local j5 = `i' - 4
local j6 = `i' - 3
local j7 = `i' - 2
local j8 = `i' - 1
local j9 = `i' - 0
gen disinflation_indicator`j5' =0
gen peak_test`j5' = 0
novarabbrev {
replace peak_test`j5' = 1 if type_id==1 & inf_ma9_`j5'> inf_ma9_`j1' & inf_ma9_`j5'> inf_ma9_`j2' & inf_ma9_`j5'> inf_ma9_`j3' & inf_ma9_`j5'> inf_ma9_`j4' & inf_ma9_`j5'> inf_ma9_`j6' & inf_ma9_`j5'> inf_ma9_`j7' & inf_ma9_`j5'> inf_ma9_`j8' & inf_ma9_`j5'> inf_ma9_`j9' 
replace type_id = 2 if type_id==1 & inf_ma9_`j5'> inf_ma9_`j1' & inf_ma9_`j5'> inf_ma9_`j2' & inf_ma9_`j5'> inf_ma9_`j3' & inf_ma9_`j5'> inf_ma9_`j4' & inf_ma9_`j5'> inf_ma9_`j6' & inf_ma9_`j5'> inf_ma9_`j7' & inf_ma9_`j5'> inf_ma9_`j8' & inf_ma9_`j5'> inf_ma9_`j9' 
replace disinflation_indicator`j5' = counter if type_id==2
replace peak_test`j5' = 2 if type_id==2 & inf_ma9_`j5'< inf_ma9_`j1' & inf_ma9_`j5'< inf_ma9_`j2' & inf_ma9_`j5'< inf_ma9_`j3' & inf_ma9_`j5'< inf_ma9_`j4' & inf_ma9_`j5'< inf_ma9_`j6' & inf_ma9_`j5'< inf_ma9_`j7' & inf_ma9_`j5'< inf_ma9_`j8' & inf_ma9_`j5'< inf_ma9_`j9' 
replace type_id = 1 if type_id==2 & inf_ma9_`j5'< inf_ma9_`j1' & inf_ma9_`j5'< inf_ma9_`j2' & inf_ma9_`j5'< inf_ma9_`j3' & inf_ma9_`j5'< inf_ma9_`j4' & inf_ma9_`j5'< inf_ma9_`j6' & inf_ma9_`j5'< inf_ma9_`j7' & inf_ma9_`j5'< inf_ma9_`j8' & inf_ma9_`j5'< inf_ma9_`j9' 
replace counter = counter + 1 if type_id==1 & inf_ma9_`j5'< inf_ma9_`j1' & inf_ma9_`j5'< inf_ma9_`j2' & inf_ma9_`j5'< inf_ma9_`j3' & inf_ma9_`j5'< inf_ma9_`j4' & inf_ma9_`j5'< inf_ma9_`j6' & inf_ma9_`j5'< inf_ma9_`j7' & inf_ma9_`j5'< inf_ma9_`j8' & inf_ma9_`j5'< inf_ma9_`j9' 
}
}



reshape long inflation inf_ma9_ peak_test disinflation_indicator, i(location) j(quarter)

egen test = max(peak_test), by(location disinflation_ind)

replace disinflation_ind = 0 if test!=2

xtset country_id quarter, quarterly

*tsline inf_ma9 peak_ if country_id==15

******************************************************************************
** Keep only the quantities we care about
******************************************************************************
drop type_id 

* Adding disinflation indicator
preserve

drop if peak==0 | peak==.
gen change_inflation = 0

forv i = 1(1)49{
replace change_inflation = inf_ma[_n] - inf_ma[_n+1] if country_id == `i'
}

gen indicator = .
forv i = 1(1)49{
replace indicator = peak[_n] - peak[_n+1] if country_id == `i'
}

sort location quarter

* Fix an end of sample issue with Argentina data
replace indicator = 1 if peak==2 & indicator==.

gen temp = change[_n-1]

*keep if change>2 | temp>2

replace change_inf = temp if indicator==1

*drop if indicator==0

*drop if change<2

drop temp

save disinflation_episodes, replace

restore

*Put the data set back together

merge 1:1 country_id quarter using disinflation_episodes

drop _merge

***************************************************************************
*Add GDP data back to disinflation information
***************************************************************************

*add extra gdp observations for Chile from Kulish data
preserve

use oecd_gdp_growth, clear

reshape long gdp, i(location) j(quarter)

merge 1:1 country_id quarter using matching_chile_data, update

drop _merge

save reshaped_oecd_gdp_growth, replace

restore

*Merge GDP Data
merge 1:1 location quarter using reshaped_oecd_gdp_growth

drop _merge

*** ADD in New Output Data from FRED

replace location = lower(location)

replace location = "china" if location=="china (people's republic of)"

merge 1:1 location quarter using supp_gdp_data, update

gen annual_data = 0
replace annual_data = 1 if _merge==4

drop _merge

merge 1:1 location quarter using wb_supp_gdp_data, update
replace annual_data = 1 if _merge==4
drop _merge

****************************************************************************
*Indentify the time periods where disinflation output costs will be calculated
*****************************************************************************

replace disinflation=. if disinflation==0

egen disinflation_id = group(country disinflation)

*replace disinflation_id = . if disinflation_ind==0

drop counter 

egen temp = max(change), by(disinflation_id)
 
replace change = temp

drop temp

drop country_id

egen country_id = group(location)

sort country_id quarter

*****************************************************************************
* ADD length of disinflation *
*****************************************************************************
egen time = seq(), by(disinflation_id)
replace time =. if disinflation_id==.
egen dis_duration = max(time), by(disinflation_id)

***************************************************************************
* Calculate trend output using Ball's Definitions
***************************************************************************

* Generate indicator to ensure there is gdp data to cover the entire episode
egen test2 = count(gdp), by(disinflation_id)

gen test3 = 0
replace test3 = 1 if test2==dis_duration

*rename gdp gdp_growth

rename gdp gdp_growth

*replace missing observations with 0

replace gdp_growth = 0 if gdp_growth==.

*create new variable for log gdp call yhat
gen yhat = 1000

bysort country_id (quarter): replace yhat = yhat[_n-1] *(1+gdp/100) if _n>1

replace yhat = ln(yhat)

* Identify periods to calculate trend
gen ball_def_gdp=.

replace ball_def = yhat if indicator==-1 & test3==1

replace ball_def = yhat[_n+4] if indicator==1  & test3==1

gen ball_def_date=.

replace ball_def_date = quarter if indicator==-1  & test3==1

replace ball_def_date = quarter[_n+4] if indicator==1  & test3==1

gen linear_trend=.

egen dis_trend_id = group(location disinflation_id) if test3==1

sum dis_trend_id

forv i=1(1)`r(max)' {
reg ball_def_gdp ball_def_date if dis_trend_id==`i'
gen slope =_b[ball_def_date]
gen constant = _b[_cons]
replace linear_trend = slope*quarter + constant if dis_trend_id==`i'
drop slope constant
}

*******************************************************************************
*Alternative measures of the SaR
*******************************************************************************
* mean growth
egen mean_growth = mean(gdp), by(country_id)

gen demeaned_growth = gdp - mean_growth

* trend growth
xtset country_id quarter, quarterly

xi: qui xtreg gdp i.country_id*quarter, fe
predict trend_gdp, xb

gen detrended_growth = gdp - trend_gdp

drop _Icou*

*******************************************************************************
*Calculating SaRs
*******************************************************************************

* Ball's measure of sacrafice ration

* Note: Multiplying by 40 is the only way to recover Ball's numbers.

gen outputgap = (yhat - linear_trend)*100
egen cumulative = sum(outputgap), by(dis_trend_id)
gen b_sacrifice_ratios = -(1/change)*cumu if indicator==-1 & dis_trend_id!=.

* Growth rate measures
egen temp = sum(demeaned_growth), by(dis_trend_id)
gen m_sacrifice_ratios = -1/change*temp if indicator==-1 & dis_trend_id!=.
drop temp

egen temp = sum(detrended_growth), by(dis_trend_id)
gen t_sacrifice_ratios = -1/change*temp if indicator==-1 & dis_trend_id!=.
drop temp

*******************************************************************************
* Add interest rate data, classify as developed, and calulated disinflation duration
*******************************************************************************

preserve

use oecd_interest_rates, clear

reshape long interest, i(location) j(quarter)

replace location = lower(location)

save reshaped_oecd_interest, replace

restore

*Merge interest Data
merge 1:1 location quarter using reshaped_oecd_interest

drop _merge

merge 1:1 location quarter using supp_interest_data, update

drop _merge

*** Group Contries as Developing and Developed

gen developed = 0

replace developed = 1 if location == "australia"
replace developed = 1 if location == "canada"
replace developed = 1 if location == "united states"
replace developed = 1 if location == "france"
replace developed = 1 if location == "germany"
replace developed = 1 if location == "italy"
replace developed = 1 if location == "united kingdom"
replace developed = 1 if location == "japan"
replace developed = 1 if location == "south korea"
replace developed = 1 if location == "austria"
replace developed = 1 if location == "belgium"
replace developed = 1 if location == "denmark"
replace developed = 1 if location == "finland"
replace developed = 1 if location == "greece"
replace developed = 1 if location == "iceland"
replace developed = 1 if location == "ireland"
replace developed = 1 if location == "israel"
replace developed = 1 if location == "luxembourg"
replace developed = 1 if location == "netherlands"
replace developed = 1 if location == "new zealand"
replace developed = 1 if location == "norway"
replace developed = 1 if location == "sweden"
replace developed = 1 if location == "portugal"
replace developed = 1 if location == "spain"
replace developed = 1 if location == "switzerland"
replace developed = 1 if location == "korea"

** Indicate Aggregate measures
drop if location =="g7"
drop if location =="oecd - total"
drop if location =="oecd - europe"
drop if location=="euro area (18 countries)"
drop if location=="euro area (19 countries)"
drop if location=="european union (28 countries)"
drop if location=="g20"
sort location quarter

** Add Credibility Data
merge 1:1 location quarter using credibility_data

drop if _merge==2

drop _merge

drop if location=="china (people's republic of)"

replace change=. if linear_trend==.

format %100s location

gen dis_end = quarter + dis_dur

format %tq dis_end

save sacrifice_data, replace


